" FILE: Lfunctree.vim
" AUTHOR:  yuratomo
" Last Modified: 31 Jan 2012.
" Version: 0.0.1

if exists('g:Lfunctree_loaded') && g:Lfunctree_loaded == 1
  finish
endif
if !exists('g:Lcore_loaded') || g:Lcore_loaded == 0
  runtime plugin/Lcore.vim
endif

let g:Lfunctree_title = Lcore#RegistPlugin('Lfunctree')
let g:Lfunctree_show_mode = 0

if !exists("g:Lfunctree_file")
  let g:Lfunctree_file = $home.'\\.vim_cflow'
endif
let g:Lfunctree_list = []
if !exists('g:Lfunctree_cmd')
  let g:Lfunctree_cmd = 'functree'
endif

if !exists('g:Lfunctree_only_current_file')
  let g:Lfunctree_only_current_file = 0
endif

command! -nargs=0 Lfunctree :call Lfunctree#Show_()

function! Lfunctree#Show_()
  let g:Lfunctree_show_mode = 1
  call Lfunctree#Show()
endfunction

function! Lfunctree#Show()
  call Lcore#Close()

  if g:Lfunctree_show_mode == 0
    return
  endif
  let g:Lfunctree_show_mode = 0

  if g:Lfunctree_only_current_file == 1
    let g:Lfunctree_list = split(system(g:Lfunctree_cmd.' '.expand('%')), '\n')
  else
    let g:Lfunctree_list = split(system(g:Lfunctree_cmd.' *.cpp *.h *.c'), '\n')
  endif

  exe ':topleft new '.g:Lfunctree_title
  exe ':res '.g:Lcore_line_num
  call Lfunctree#Update()
  setlocal bt=nofile cursorline ft=cpp
  call Lcore#HilightTitle()

  call Lcore#CommonSetting()
endfunction

function! Lfunctree#Update()
  setlocal modifiable
  let list = g:Lfunctree_list
  let g:Lfunctree_show_mode = 1
  call Lcore#Show(list)
  call Lcore#SetCursorTop()
endfunction

function! Lfunctree#Open(line)
  let part = filter(split(a:line, ' '), "v:val != ''")
  wincmd p
  if filereadable(part[0])
    exe ':e +'.part[1].' '.part[0]
    normal zt
  endif
endfunction

function! Lfunctree#Delete()
endfunction

function! Lfunctree#Sort()
endfunction

let g:Lfunctree_loaded = 1
