" FILE: Lquickfix.vim
" AUTHOR:  yuratomo
" Last Modified: 31 Jan 2012.
" Version: 0.0.1

if exists('g:Lquickfix_loaded') && g:Lquickfix_loaded == 1
  finish
endif
if !exists('g:Lcore_loaded') || g:Lcore_loaded == 0
  runtime plugin/Lcore.vim
endif

let g:Lquickfix_title = Lcore#RegistPlugin('Lquickfix')
let g:Lquickfix_list = []
let g:Lquickfix_sort = 1
let g:Lquickfix_pwd  = ''

command! -nargs=? Lquickfix :call Lquickfix#Show(<f-args>)

augroup Lquickfix
 au!
 au QuickFixCmdPost * call Lquickfix#QuickFix()
augroup END

function! Lquickfix#QuickFix()
  call Lquickfix#CreateList()
  "call Lquickfix#Show()
  wincmd p
endfunction

function! Lquickfix#Show()
  let g:Lcore_refine_word = ''
  call Lcore#Close()
  if exists("a:1")
    let g:Lcore_refine_word = a:1
  endif
  if len(g:Lquickfix_list) <= 0
    return
  endif
  exe ':topleft new '.g:Lquickfix_title
  exe ':res '.g:Lcore_line_num
  silent call Lquickfix#Update()
  setl ft=cpp
  call Lcore#CommonSetting()
  call Lcore#HilightTitle()
endfunction

function! Lquickfix#CreateList()
  let g:Lquickfix_pwd  = expand('%:p:h')
  let g:Lquickfix_list = []
  let first = 1
  for item in getqflist()
    call add(g:Lquickfix_list, bufname(item.bufnr).'|'.item.lnum.'|'.item.text)
    if first == 1
      let first = 0
      let name = bufname(item.bufnr)
      let g:Lquickfix_ext = name[strridx(name,".")+1:]
    endif
  endfor
endfunction

function! Lquickfix#Update()
  setlocal modifiable
  let list = copy(g:Lquickfix_list)
  call Lcore#Refine(list)
  call Lcore#Clear()
  call Lcore#Show(list)
  call Lcore#SetCursorTop()
  setlocal nomodifiable
endfunction

function! Lquickfix#Open(line)
  let parts = split(a:line, '|')
  wincmd p
  if g:Lquickfix_pwd != expand('%:p:h')
    exe 'cd '.g:Lquickfix_pwd
  endif
  exe ':e +'.parts[1].' '.parts[0]
  normal zt
endfunction

function! Lquickfix#Delete()
endfunction

function! Lquickfix#Sort()
endfunction

let g:Lquickfix_loaded = 1
